

public:
	/** Set a term reference, using a URN to reference the classification scheme.
	  * @param urn The URN of the classification scheme.
	  * @param term The term ID.
	  * @param name The name of the term (optional). If name is NULL, no name element will be written.
	  * @param client ID of the client modifying the element.
	  */
	virtual void SetTermReferenceURN(XMLCh* urn, XMLCh* term, XMLCh* name, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/** Set a term reference, using a URI to reference the classification scheme.
	  * @param urn The URI of the classification scheme.
	  * @param term The term ID.
	  * @param name The name of the term (optional). If name is NULL, no name element will be written.
	  * @param client ID of the client modifying the element.
	  */
	virtual void SetTermReferenceAnyURI(XMLCh* uri, XMLCh* term, XMLCh* name, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/** Get a term reference.
	  * @param uri Contains the URI/URN of the classification scheme after return. 
	  *        The caller is responsible for releasing this string by calling XMLString::release().
	  * @param term Contains the term ID after return.
	  *        The caller is responsible for releasing this string by calling XMLString::release().
	  */
	virtual void GetTermReference(XMLCh** uri, XMLCh** term);


private:
	/** Set the name element for the term reference. */
	void SetTermName(XMLCh* name, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);
