#include "Mp7JrsmediaTimePointType.h"
#include "Mp7JrsMediaTimeType.h"
#include "Mp7JrsMediaLocatorType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsDSType.h"

int IMp7JrsMediaRelTimePointType::GetTotalNrFractions() {
	int sum = 0;
	// days missing!!!!!
	sum = 60 * (GetHours() + sum);
	sum = 60 * (GetMinutes() + sum);
	sum = GetFractionsPerSecond() * (GetSeconds() + sum);
	sum += GetNumberOfFractions(); 
	return sum;
}

void IMp7JrsMediaRelTimePointType::SetTotalNrFractions(int fractions, Mp7JrsClientID client) {
	int remainder = fractions;
	SetNumberOfFractions(remainder % GetFractionsPerSecond(),client);
	remainder /= GetFractionsPerSecond();
	SetSeconds (remainder % 60,client);
	remainder /= 60;
	SetMinutes (remainder % 60,client);
	remainder /= 60;
	SetHours (remainder,client);
	// days ignored
}



Mp7JrsmediaTimePointPtr IMp7JrsMediaRelTimePointType::GetAbsMediaTimePoint() {
	Mp7JrsmediaTimePointPtr absTp = CreatemediaTimePointType;
	Mp7JrsmediaTimePointPtr relTp = _GetMediaTimeBase();
	absTp->SetFractionsPerSecond(GetFractionsPerSecond());
	int nFractions = (int)(GetTotalNrFractions()+(relTp->GetTotalNrFractions()*1.0/relTp->GetFractionsPerSecond())*GetFractionsPerSecond());
	absTp->SetTotalNrFractions(nFractions);
	return absTp;
}

void IMp7JrsMediaRelTimePointType::SetAbsMediaTimePoint(Mp7JrsmediaTimePointPtr tp, Mp7JrsClientID client) {
	Mp7JrsmediaTimePointPtr relTp = _GetMediaTimeBase();
	SetFractionsPerSecond(tp->GetFractionsPerSecond(),client);
	int nFractions = (int)(tp->GetTotalNrFractions()+(relTp->GetTotalNrFractions()*1.0/relTp->GetFractionsPerSecond())*tp->GetFractionsPerSecond());
	SetTotalNrFractions(nFractions,client);	
}

Mp7JrsmediaTimePointPtr IMp7JrsMediaRelTimePointType::_GetMediaTimeBase() {
	Mp7JrsxPathRefPtr mtbPath;
	Mp7JrsNodePtr parent;
	if (ExistmediaTimeBase()) mtbPath = GetmediaTimeBase();
	else {
		parent = GetParent();
		while (parent) {
			Mp7JrsDSPtr dstype = parent;
			if (dstype) {
				if (dstype->ExistmediaTimeBase()) {
					mtbPath = dstype->GetmediaTimeBase();
					break;
				}
			}
			parent = parent->GetParent();
		}
	}

	
	Mp7JrsmediaTimePointPtr nullTp;
	// if no path found return empty time point
	if (mtbPath==NULL) return nullTp;

	// try to resolve XPath
	Mp7JrsNodePtr target;
	if (parent) target = parent->NodeFromXPath(mtbPath->GetContent());
	else target = NodeFromXPath(mtbPath->GetContent());

	// no target found
	if (target==NULL) return nullTp;

	// check if target is a MediaTimeType
	Mp7JrsMediaTimePtr mediaTime = target;
	if (mediaTime) {
		// try to get time point
		Mp7JrsmediaTimePointPtr mtp = mediaTime->GetMediaTimePoint();
		// if not, try to get absolute value of relative tp
		if (mtp!=NULL) return mtp;

		Mp7JrsMediaRelTimePointPtr mrtp = mediaTime->GetMediaRelTimePoint();
		if (mrtp==NULL) return nullTp;

		mtp = mrtp->GetAbsMediaTimePoint();
		return mtp;
	}
	// check if target is a MediaLocator
	Mp7JrsMediaLocatorPtr mediaLoc = target;
	if (mediaLoc) {
		// not well defined in schema, has to be done in own extension
		return nullTp;
	}

	return nullTp;
}
