

public:

	/** Get the begin time.
	  * @return Pointer to begin time.
	  */
	virtual Mp7JrsmediaTimePointPtr GetBeginTime();

	/** Set begin time.
	  *	@param beginTime Begin time to be set (will be copied).
	  */
	virtual void SetBeginTime(const Mp7JrsmediaTimePointPtr &beginTime, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/** Get the end time.
	  * @return Pointer to end time.
	  */
	virtual Mp7JrsmediaTimePointPtr GetEndTime();

	/** Set end time.
	  *	@param endTime End time to be set (will be copied).
	  */
	virtual void SetEndTime(const Mp7JrsmediaTimePointPtr &endTime, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT); 

	/** Get begin and end time. 
	  * beginTime and endTime contain the time points after return.
	  */
	virtual void GetTime(Mp7JrsmediaTimePointPtr& beginTime, Mp7JrsmediaTimePointPtr& endTime);

	/** Set begin and end time. The time points will be copied. */
	virtual void SetTime(const Mp7JrsmediaTimePointPtr &beginTime, const Mp7JrsmediaTimePointPtr &endTime, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/** Checks whether the given time point is within the media time. */
	virtual bool IsInside(const Mp7JrsmediaTimePointPtr &timePoint);
