
Mp7JrsmediaTimePointPtr IMp7JrsMediaTimeType::GetBeginTime() {
	return GetMediaTimePoint();
}

void IMp7JrsMediaTimeType::SetBeginTime(const Mp7JrsmediaTimePointPtr &beginTime, Mp7JrsClientID client)
{
	// FIXME: generated Setter methods store the passed object, not a
	// clone of it.  Should we do the same here?
	SetMediaTimePoint(Mp7JrsmediaTimePointPtr(Mp7JrsFactory::CloneObject(beginTime)),client);
}

Mp7JrsmediaTimePointPtr IMp7JrsMediaTimeType::GetEndTime() {

	Mp7JrsFactory::DeleteObject(_endTime);

	_endTime = (Mp7JrsmediaTimePointPtr) Mp7JrsFactory::CloneObject(GetBeginTime());
	
	if (GetMediaDuration()) {
		_endTime->Add(GetMediaDuration());
	}
	return _endTime;
}

void IMp7JrsMediaTimeType::SetEndTime(const Mp7JrsmediaTimePointPtr &endTime, Mp7JrsClientID client)
{
	Mp7JrsFactory::DeleteObject(_endTime);
	_endTime = Mp7JrsmediaTimePointPtr(Mp7JrsFactory::CloneObject(endTime));
	SetMediaDuration(_endTime->Subtract(GetMediaTimePoint()),client);
}

void IMp7JrsMediaTimeType::GetTime(Mp7JrsmediaTimePointPtr& beginTime, Mp7JrsmediaTimePointPtr& endTime) {
	beginTime = GetBeginTime();
	endTime = GetEndTime();
}

void IMp7JrsMediaTimeType::SetTime(const Mp7JrsmediaTimePointPtr &beginTime, const Mp7JrsmediaTimePointPtr &endTime, Mp7JrsClientID client) {
	SetBeginTime(beginTime,client);
	SetEndTime(endTime,client);
}

bool IMp7JrsMediaTimeType::IsInside(const Mp7JrsmediaTimePointPtr &timePoint){

	Mp7JrsmediaTimePointPtr endTime = GetEndTime();
	Mp7JrsmediaTimePointPtr beginTime = GetBeginTime();

	if ((timePoint->GetTotalNrFractions() >= beginTime->GetTotalNrFractions())
		&& (timePoint->GetTotalNrFractions() <= endTime->GetTotalNrFractions())) {
		return true;
	}
	else {
		return false;
	}

}

