
#include "Mp7JrsImageLocatorType.h"
#include "Mp7JrsMediaTimeType.h"
#include "Mp7JrsTextualType.h"
#include "Mp7JrsmediaTimePointType.h"
#include "Mp7JrstextualBaseType.h"

void IMp7JrsSummarySegmentType::AddKeyframe(Mp7JrsmediaTimePointPtr timepoint, bool copyTimePoint, Mp7JrsClientID client) {
	if (GetKeyFrame()==NULL) SetKeyFrame(CreateSummarySegmentType_KeyFrame_CollectionType, client);
	Mp7JrsImageLocatorPtr locator = CreateImageLocatorType;
	
	Mp7JrsmediaTimePointPtr tp = timepoint;
	if (copyTimePoint) tp = (Mp7JrsmediaTimePointPtr) Mp7JrsFactory::CloneObject(timepoint);

	locator->SetMediaTimePoint(tp, client);
	GetKeyFrame()->addElement(locator);
}

int IMp7JrsSummarySegmentType::GetNrKeyframes() {
	if (GetKeyFrame()==NULL) return 0;
	return GetKeyFrame()->size();
}

///////

void IMp7JrsSummarySegmentType::SetKeyVideoClip(Mp7JrsmediaTimePointPtr beginTime, Mp7JrsmediaTimePointPtr endTime, bool copyTimePoints, Mp7JrsClientID client) {
	if (GetKeyVideoClip()==NULL) SetKeyVideoClip(CreateTemporalSegmentLocatorType, client);
	GetKeyVideoClip()->SetMediaTime(CreateMediaTimeType, client);
	Mp7JrsmediaTimePointPtr beginTp = beginTime;
	Mp7JrsmediaTimePointPtr endTp = endTime;
	if (copyTimePoints) {
		beginTp = (Mp7JrsmediaTimePointPtr) Mp7JrsFactory::CloneObject(beginTime);
		endTp = (Mp7JrsmediaTimePointPtr) Mp7JrsFactory::CloneObject(endTime);
	}
	GetKeyVideoClip()->GetMediaTime()->SetTime(beginTp,endTp,client);
}

void IMp7JrsSummarySegmentType::GetKeyVideoClip(Mp7JrsmediaTimePointPtr& beginTime, Mp7JrsmediaTimePointPtr& endTime) {
	if (GetKeyVideoClip()==NULL) return;
	GetKeyVideoClip()->GetMediaTime()->GetTime(beginTime,endTime);
}


void IMp7JrsSummarySegmentType::AddName(XMLCh* name, Mp7JrsClientID client) {
	Mp7JrsTextualPtr text = CreateTextualType;
	text->SetContent(name, client);
	GetName()->addElement(text, client);
}
