#include "Mp7JrsdurationType.h"

void IMp7JrstimePointType::Add(Mp7JrsdurationPtr duration, Mp7JrsClientID client) {
	int nFractions = (int)(GetTotalNrFractions()+(duration->GetTotalNrFractions()*1.0/duration->GetFractionsPerSecond())*GetFractionsPerSecond());
	SetTotalNrFractions(nFractions,client);
}

Mp7JrsdurationPtr IMp7JrstimePointType::Subtract(Mp7JrstimePointPtr timePoint, Mp7JrsClientID client) {
	int nFractions = (int)(GetTotalNrFractions()-(timePoint->GetTotalNrFractions()*1.0/timePoint->GetFractionsPerSecond())*GetFractionsPerSecond());
	Mp7JrsdurationPtr duration = CreatedurationType;
	duration->SetFractionsPerSecond(GetFractionsPerSecond(),client);
	duration->SetTotalNrFractions(nFractions,client);
	return duration;
}

int IMp7JrstimePointType::GetTotalNrFractions() {
	int sum = 0;
	// days and months missing!!!!!
	sum = 60 * (GetHours() + sum);
	sum = 60 * (GetMinutes() + sum);
	sum = GetFractionsPerSecond() * (GetSeconds() + sum);
	sum += GetNumberOfFractions(); 
	return sum;
}

void IMp7JrstimePointType::SetTotalNrFractions(int fractions, Mp7JrsClientID client) {
	int remainder = fractions;
	SetNumberOfFractions(remainder % GetFractionsPerSecond(),client);
	remainder /= GetFractionsPerSecond();
	SetSeconds (remainder % 60,client);
	remainder /= 60;
	SetMinutes (remainder % 60,client);
	remainder /= 60;
	SetHours (remainder,client);
	// days and months ignored!!!!
}

