/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _67MP7JRSANALYTICEDITEDVIDEOSEGMENTSPATIOTEMPORALDECOMPOSITIONTYPE_LOCALTYPE_H
#define _67MP7JRSANALYTICEDITEDVIDEOSEGMENTSPATIOTEMPORALDECOMPOSITIONTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType_ExtInclude.h


class IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType;
class IMp7JrsEditedMovingRegionType;
class IMp7JrsReferenceType;
typedef Mp7JrsPtr< IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType> Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsEditedMovingRegionType > Mp7JrsEditedMovingRegionPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;

/** 
 * Generated interface IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType for class Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType();
    virtual ~IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get EditedMovingRegion element.
     * @return Mp7JrsEditedMovingRegionPtr
     */
    virtual Mp7JrsEditedMovingRegionPtr GetEditedMovingRegion() const = 0;

    /**
     * Set EditedMovingRegion element.
     * @param item const Mp7JrsEditedMovingRegionPtr &
     */
    // Mandatory			
    virtual void SetEditedMovingRegion(const Mp7JrsEditedMovingRegionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get EditedMovingRegionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetEditedMovingRegionRef() const = 0;

    /**
     * Set EditedMovingRegionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetEditedMovingRegionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType<br>
 * Defined in mds-2001.xsd, line 3975.<br>
 */
class MP7JRS_EXPORT Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType :
        public IMp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType
{
    friend class Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get EditedMovingRegion element.
     * @return Mp7JrsEditedMovingRegionPtr
     */
    virtual Mp7JrsEditedMovingRegionPtr GetEditedMovingRegion() const;

    /*
     * Set EditedMovingRegion element.
     * @param item const Mp7JrsEditedMovingRegionPtr &
     */
    // Mandatory			
    virtual void SetEditedMovingRegion(const Mp7JrsEditedMovingRegionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get EditedMovingRegionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetEditedMovingRegionRef() const;

    /*
     * Set EditedMovingRegionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetEditedMovingRegionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType();

protected:
    Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsEditedMovingRegionPtr m_EditedMovingRegion;
    Mp7JrsReferencePtr m_EditedMovingRegionRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsAnalyticEditedVideoSegmentSpatioTemporalDecompositionType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _67MP7JRSANALYTICEDITEDVIDEOSEGMENTSPATIOTEMPORALDECOMPOSITIONTYPE_LOCALTYPE_H

