/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _487MP7JRSCOLORQUANTIZATIONTYPE_LOCALTYPE_H
#define _487MP7JRSCOLORQUANTIZATIONTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsColorQuantizationType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_LocalType_ExtInclude.h


#include "Mp7JrsColorQuantizationType_Component_LocalType.h"
class IMp7JrsColorQuantizationType_LocalType;
class IMp7Jrsunsigned12;
typedef Mp7JrsPtr< IMp7JrsColorQuantizationType_LocalType> Mp7JrsColorQuantizationType_LocalPtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned12 > Mp7Jrsunsigned12Ptr;

/** 
 * Generated interface IMp7JrsColorQuantizationType_LocalType for class Mp7JrsColorQuantizationType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsColorQuantizationType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsColorQuantizationType_LocalType();
    virtual ~IMp7JrsColorQuantizationType_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Component element.
     * @return Mp7JrsColorQuantizationType_Component_LocalType::Enumeration
     */
    virtual Mp7JrsColorQuantizationType_Component_LocalType::Enumeration GetComponent() const = 0;

    /**
     * Set Component element.
     * @param item Mp7JrsColorQuantizationType_Component_LocalType::Enumeration
     */
    // Mandatory			
    virtual void SetComponent(Mp7JrsColorQuantizationType_Component_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get NumOfBins element.
     * @return Mp7Jrsunsigned12Ptr
     */
    virtual Mp7Jrsunsigned12Ptr GetNumOfBins() const = 0;

    /**
     * Set NumOfBins element.
     * @param item const Mp7Jrsunsigned12Ptr &
     */
    // Mandatory			
    virtual void SetNumOfBins(const Mp7Jrsunsigned12Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsColorQuantizationType_LocalType<br>
 * Defined in visual-2001.with.net.workaround.xsd, line 273.<br>
 */
class MP7JRS_EXPORT Mp7JrsColorQuantizationType_LocalType :
        public IMp7JrsColorQuantizationType_LocalType
{
    friend class Mp7JrsColorQuantizationType_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get Component element.
     * @return Mp7JrsColorQuantizationType_Component_LocalType::Enumeration
     */
    virtual Mp7JrsColorQuantizationType_Component_LocalType::Enumeration GetComponent() const;

    /*
     * Set Component element.
     * @param item Mp7JrsColorQuantizationType_Component_LocalType::Enumeration
     */
    // Mandatory			
    virtual void SetComponent(Mp7JrsColorQuantizationType_Component_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get NumOfBins element.
     * @return Mp7Jrsunsigned12Ptr
     */
    virtual Mp7Jrsunsigned12Ptr GetNumOfBins() const;

    /*
     * Set NumOfBins element.
     * @param item const Mp7Jrsunsigned12Ptr &
     */
    // Mandatory			
    virtual void SetNumOfBins(const Mp7Jrsunsigned12Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsColorQuantizationType_LocalType();

protected:
    Mp7JrsColorQuantizationType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsColorQuantizationType_Component_LocalType::Enumeration m_Component;
    Mp7Jrsunsigned12Ptr m_NumOfBins;

// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _487MP7JRSCOLORQUANTIZATIONTYPE_LOCALTYPE_H

