/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _553MP7JRSCONCEPTCOLLECTIONTYPE_LOCALTYPE0_H
#define _553MP7JRSCONCEPTCOLLECTIONTYPE_LOCALTYPE0_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConceptCollectionType_LocalType0Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsConceptCollectionType_LocalType0_ExtInclude.h


class IMp7JrsConceptCollectionType;
class IMp7JrsConceptCollectionType_LocalType0;
class IMp7JrsReferenceType;
typedef Mp7JrsPtr< IMp7JrsConceptCollectionType > Mp7JrsConceptCollectionPtr;
typedef Mp7JrsPtr< IMp7JrsConceptCollectionType_LocalType0> Mp7JrsConceptCollectionType_Local0Ptr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;

/** 
 * Generated interface IMp7JrsConceptCollectionType_LocalType0 for class Mp7JrsConceptCollectionType_LocalType0<br>
 */
class MP7JRS_EXPORT IMp7JrsConceptCollectionType_LocalType0 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsConceptCollectionType_LocalType0();
    virtual ~IMp7JrsConceptCollectionType_LocalType0();
        /** @name Choice

         */
        //@{
    /**
     * Get ConceptCollection element.
     * @return Mp7JrsConceptCollectionPtr
     */
    virtual Mp7JrsConceptCollectionPtr GetConceptCollection() const = 0;

    /**
     * Set ConceptCollection element.
     * @param item const Mp7JrsConceptCollectionPtr &
     */
    virtual void SetConceptCollection(const Mp7JrsConceptCollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ConceptCollectionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetConceptCollectionRef() const = 0;

    /**
     * Set ConceptCollectionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetConceptCollectionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsConceptCollectionType_LocalType0_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsConceptCollectionType_LocalType0_ExtPropDef.h

};




/*
 * Generated class Mp7JrsConceptCollectionType_LocalType0<br>
 * Defined in mds-2001.xsd, line 5306.<br>
 */
class MP7JRS_EXPORT Mp7JrsConceptCollectionType_LocalType0 :
        public IMp7JrsConceptCollectionType_LocalType0
{
    friend class Mp7JrsConceptCollectionType_LocalType0Factory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get ConceptCollection element.
     * @return Mp7JrsConceptCollectionPtr
     */
    virtual Mp7JrsConceptCollectionPtr GetConceptCollection() const;

    /*
     * Set ConceptCollection element.
     * @param item const Mp7JrsConceptCollectionPtr &
     */
    virtual void SetConceptCollection(const Mp7JrsConceptCollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ConceptCollectionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetConceptCollectionRef() const;

    /*
     * Set ConceptCollectionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetConceptCollectionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsConceptCollectionType_LocalType0_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsConceptCollectionType_LocalType0();

protected:
    Mp7JrsConceptCollectionType_LocalType0();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsConceptCollectionPtr m_ConceptCollection;
    Mp7JrsReferencePtr m_ConceptCollectionRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsConceptCollectionType_LocalType0_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _553MP7JRSCONCEPTCOLLECTIONTYPE_LOCALTYPE0_H

