/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _571MP7JRSCONTENTCOLLECTIONTYPE_LOCALTYPE0_H
#define _571MP7JRSCONTENTCOLLECTIONTYPE_LOCALTYPE0_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsContentCollectionType_LocalType0Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsContentCollectionType_LocalType0_ExtInclude.h


class IMp7JrsContentCollectionType_LocalType0;
class IMp7JrsMultimediaContentType;
class IMp7JrsReferenceType;
typedef Mp7JrsPtr< IMp7JrsContentCollectionType_LocalType0> Mp7JrsContentCollectionType_Local0Ptr;
typedef Mp7JrsPtr< IMp7JrsMultimediaContentType > Mp7JrsMultimediaContentPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;

/** 
 * Generated interface IMp7JrsContentCollectionType_LocalType0 for class Mp7JrsContentCollectionType_LocalType0<br>
 */
class MP7JRS_EXPORT IMp7JrsContentCollectionType_LocalType0 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsContentCollectionType_LocalType0();
    virtual ~IMp7JrsContentCollectionType_LocalType0();
        /** @name Choice

         */
        //@{
    /**
     * Get Content element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsAnalyticEditedVideoPtr</li>
     * <li>IMp7JrsAudioPtr</li>
     * <li>IMp7JrsAudioVisualPtr</li>
     * <li>IMp7JrsImagePtr</li>
     * <li>IMp7JrsInkContentPtr</li>
     * <li>IMp7JrsMultimediaCollectionPtr</li>
     * <li>IMp7JrsMultimediaPtr</li>
     * <li>IMp7JrsSignalPtr</li>
     * <li>IMp7JrsVideoPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetContent() const = 0;

    /**
     * Set Content element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsAnalyticEditedVideoPtr</li>
     * <li>IMp7JrsAudioPtr</li>
     * <li>IMp7JrsAudioVisualPtr</li>
     * <li>IMp7JrsImagePtr</li>
     * <li>IMp7JrsInkContentPtr</li>
     * <li>IMp7JrsMultimediaCollectionPtr</li>
     * <li>IMp7JrsMultimediaPtr</li>
     * <li>IMp7JrsSignalPtr</li>
     * <li>IMp7JrsVideoPtr</li>
     * </ul>
     */
    virtual void SetContent(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ContentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetContentRef() const = 0;

    /**
     * Set ContentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetContentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsContentCollectionType_LocalType0_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsContentCollectionType_LocalType0_ExtPropDef.h

};




/*
 * Generated class Mp7JrsContentCollectionType_LocalType0<br>
 * Defined in mds-2001.xsd, line 5245.<br>
 */
class MP7JRS_EXPORT Mp7JrsContentCollectionType_LocalType0 :
        public IMp7JrsContentCollectionType_LocalType0
{
    friend class Mp7JrsContentCollectionType_LocalType0Factory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get Content element.
     * @return Mp7JrsPtr< Mp7JrsNode >
     * Possible types (within this library):
     * <ul>
     * <li>IMp7JrsAnalyticEditedVideoPtr</li>
     * <li>IMp7JrsAudioPtr</li>
     * <li>IMp7JrsAudioVisualPtr</li>
     * <li>IMp7JrsImagePtr</li>
     * <li>IMp7JrsInkContentPtr</li>
     * <li>IMp7JrsMultimediaCollectionPtr</li>
     * <li>IMp7JrsMultimediaPtr</li>
     * <li>IMp7JrsSignalPtr</li>
     * <li>IMp7JrsVideoPtr</li>
     * </ul>
     */
    virtual Mp7JrsPtr< Mp7JrsNode > GetContent() const;

    /*
     * Set Content element.
     * @param item const Mp7JrsPtr< Mp7JrsNode > &
     * Valid types for item:
     * <ul>
     * <li>IMp7JrsAnalyticEditedVideoPtr</li>
     * <li>IMp7JrsAudioPtr</li>
     * <li>IMp7JrsAudioVisualPtr</li>
     * <li>IMp7JrsImagePtr</li>
     * <li>IMp7JrsInkContentPtr</li>
     * <li>IMp7JrsMultimediaCollectionPtr</li>
     * <li>IMp7JrsMultimediaPtr</li>
     * <li>IMp7JrsSignalPtr</li>
     * <li>IMp7JrsVideoPtr</li>
     * </ul>
     */
    virtual void SetContent(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ContentRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetContentRef() const;

    /*
     * Set ContentRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetContentRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsContentCollectionType_LocalType0_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsContentCollectionType_LocalType0();

protected:
    Mp7JrsContentCollectionType_LocalType0();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsPtr< Mp7JrsNode > m_Content;
    Mp7JrsReferencePtr m_ContentRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsContentCollectionType_LocalType0_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _571MP7JRSCONTENTCOLLECTIONTYPE_LOCALTYPE0_H

