/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _691MP7JRSDEPENDENCYSTRUCTUREPHRASETYPE_LOCALTYPE_H
#define _691MP7JRSDEPENDENCYSTRUCTUREPHRASETYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsDependencyStructurePhraseType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_LocalType_ExtInclude.h


class IMp7JrsDependencyStructurePhraseType;
class IMp7JrsDependencyStructurePhraseType_LocalType;
typedef Mp7JrsPtr< IMp7JrsDependencyStructurePhraseType > Mp7JrsDependencyStructurePhrasePtr;
typedef Mp7JrsPtr< IMp7JrsDependencyStructurePhraseType_LocalType> Mp7JrsDependencyStructurePhraseType_LocalPtr;

/** 
 * Generated interface IMp7JrsDependencyStructurePhraseType_LocalType for class Mp7JrsDependencyStructurePhraseType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsDependencyStructurePhraseType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsDependencyStructurePhraseType_LocalType();
    virtual ~IMp7JrsDependencyStructurePhraseType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get Quotation element.
     * @return Mp7JrsDependencyStructurePhrasePtr
     */
    virtual Mp7JrsDependencyStructurePhrasePtr GetQuotation() const = 0;

    /**
     * Set Quotation element.
     * @param item const Mp7JrsDependencyStructurePhrasePtr &
     */
    virtual void SetQuotation(const Mp7JrsDependencyStructurePhrasePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Phrase element.
     * @return Mp7JrsDependencyStructurePhrasePtr
     */
    virtual Mp7JrsDependencyStructurePhrasePtr GetPhrase() const = 0;

    /**
     * Set Phrase element.
     * @param item const Mp7JrsDependencyStructurePhrasePtr &
     */
    virtual void SetPhrase(const Mp7JrsDependencyStructurePhrasePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsDependencyStructurePhraseType_LocalType<br>
 * Defined in mds-2001.xsd, line 1246.<br>
 */
class MP7JRS_EXPORT Mp7JrsDependencyStructurePhraseType_LocalType :
        public IMp7JrsDependencyStructurePhraseType_LocalType
{
    friend class Mp7JrsDependencyStructurePhraseType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get Quotation element.
     * @return Mp7JrsDependencyStructurePhrasePtr
     */
    virtual Mp7JrsDependencyStructurePhrasePtr GetQuotation() const;

    /*
     * Set Quotation element.
     * @param item const Mp7JrsDependencyStructurePhrasePtr &
     */
    virtual void SetQuotation(const Mp7JrsDependencyStructurePhrasePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Phrase element.
     * @return Mp7JrsDependencyStructurePhrasePtr
     */
    virtual Mp7JrsDependencyStructurePhrasePtr GetPhrase() const;

    /*
     * Set Phrase element.
     * @param item const Mp7JrsDependencyStructurePhrasePtr &
     */
    virtual void SetPhrase(const Mp7JrsDependencyStructurePhrasePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsDependencyStructurePhraseType_LocalType();

protected:
    Mp7JrsDependencyStructurePhraseType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsDependencyStructurePhrasePtr m_Quotation;
    Mp7JrsDependencyStructurePhrasePtr m_Phrase;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _691MP7JRSDEPENDENCYSTRUCTUREPHRASETYPE_LOCALTYPE_H

