/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/


#ifndef MP7JRS_DOCUMENT_H
#define MP7JRS_DOCUMENT_H

#include "Mp7JrsFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsPtr.h"

/** Represents an XML document. */
class MP7JRS_EXPORT Mp7JrsDocument {
public:
	/** Create a document with the given node as root node. */
	Mp7JrsDocument();

	Mp7JrsDocument(Mp7JrsNodePtr root); 

	virtual ~Mp7JrsDocument();

	/** Set the root node of the document. */
	void SetRoot(Mp7JrsNodePtr root); 

	/** Get the root node of the document. */
	Mp7JrsNodePtr GetRoot(); 

	/** Get a node of this document which is described by an absolute XPath expression.
	  */
	virtual Mp7JrsNodePtr GetNode(const XMLCh* xpath);

protected:
	Mp7JrsNodePtr		_root;
};

#endif
