/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _899MP7JRSGAUSSIANMIXTUREMODELTYPE_LOCALTYPE_H
#define _899MP7JRSGAUSSIANMIXTUREMODELTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsGaussianMixtureModelType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsGaussianMixtureModelType_LocalType_ExtInclude.h


class IMp7JrsGaussianDistributionType;
class IMp7JrsGaussianMixtureModelType_LocalType;
class IMp7JrsnonNegativeReal;
typedef Mp7JrsPtr< IMp7JrsGaussianDistributionType > Mp7JrsGaussianDistributionPtr;
typedef Mp7JrsPtr< IMp7JrsGaussianMixtureModelType_LocalType> Mp7JrsGaussianMixtureModelType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsnonNegativeReal > Mp7JrsnonNegativeRealPtr;

/** 
 * Generated interface IMp7JrsGaussianMixtureModelType_LocalType for class Mp7JrsGaussianMixtureModelType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsGaussianMixtureModelType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsGaussianMixtureModelType_LocalType();
    virtual ~IMp7JrsGaussianMixtureModelType_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Weight element.
     * @return Mp7JrsnonNegativeRealPtr
     */
    virtual Mp7JrsnonNegativeRealPtr GetWeight() const = 0;

    /**
     * Set Weight element.
     * @param item const Mp7JrsnonNegativeRealPtr &
     */
    // Mandatory			
    virtual void SetWeight(const Mp7JrsnonNegativeRealPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get GaussianDistribution element.
     * @return Mp7JrsGaussianDistributionPtr
     */
    virtual Mp7JrsGaussianDistributionPtr GetGaussianDistribution() const = 0;

    /**
     * Set GaussianDistribution element.
     * @param item const Mp7JrsGaussianDistributionPtr &
     */
    // Mandatory			
    virtual void SetGaussianDistribution(const Mp7JrsGaussianDistributionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsGaussianMixtureModelType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsGaussianMixtureModelType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsGaussianMixtureModelType_LocalType<br>
 * Defined in mds-2001.xsd, line 5597.<br>
 */
class MP7JRS_EXPORT Mp7JrsGaussianMixtureModelType_LocalType :
        public IMp7JrsGaussianMixtureModelType_LocalType
{
    friend class Mp7JrsGaussianMixtureModelType_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get Weight element.
     * @return Mp7JrsnonNegativeRealPtr
     */
    virtual Mp7JrsnonNegativeRealPtr GetWeight() const;

    /*
     * Set Weight element.
     * @param item const Mp7JrsnonNegativeRealPtr &
     */
    // Mandatory			
    virtual void SetWeight(const Mp7JrsnonNegativeRealPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get GaussianDistribution element.
     * @return Mp7JrsGaussianDistributionPtr
     */
    virtual Mp7JrsGaussianDistributionPtr GetGaussianDistribution() const;

    /*
     * Set GaussianDistribution element.
     * @param item const Mp7JrsGaussianDistributionPtr &
     */
    // Mandatory			
    virtual void SetGaussianDistribution(const Mp7JrsGaussianDistributionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsGaussianMixtureModelType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsGaussianMixtureModelType_LocalType();

protected:
    Mp7JrsGaussianMixtureModelType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsnonNegativeRealPtr m_Weight;
    Mp7JrsGaussianDistributionPtr m_GaussianDistribution;

// no includefile for extension defined 
// file Mp7JrsGaussianMixtureModelType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _899MP7JRSGAUSSIANMIXTUREMODELTYPE_LOCALTYPE_H

