/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1013MP7JRSINKMEDIAINFORMATIONTYPE_INPUTDEVICE_LOCALTYPE_H
#define _1013MP7JRSINKMEDIAINFORMATIONTYPE_INPUTDEVICE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsInkMediaInformationType_InputDevice_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_InputDevice_LocalType_ExtInclude.h


class IMp7JrsInkMediaInformationType_InputDevice_LocalType;
class IMp7JrsTermUseType;
typedef Mp7JrsPtr< IMp7JrsInkMediaInformationType_InputDevice_LocalType> Mp7JrsInkMediaInformationType_InputDevice_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsTermUseType > Mp7JrsTermUsePtr;

/** 
 * Generated interface IMp7JrsInkMediaInformationType_InputDevice_LocalType for class Mp7JrsInkMediaInformationType_InputDevice_LocalType<br>
 * Located at: mds-2001.xsd, line 3757<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsInkMediaInformationType_InputDevice_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsInkMediaInformationType_InputDevice_LocalType();
    virtual ~IMp7JrsInkMediaInformationType_InputDevice_LocalType();
    /**
     * Get xWidth attribute.
     * @return unsigned
     */
    virtual unsigned GetxWidth() const = 0;

    /**
     * Get xWidth attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistxWidth() const = 0;

    /**
     * Set xWidth attribute.
     * @param item unsigned
     */
    virtual void SetxWidth(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate xWidth attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatexWidth() = 0;

    /**
     * Get yWidth attribute.
     * @return unsigned
     */
    virtual unsigned GetyWidth() const = 0;

    /**
     * Get yWidth attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistyWidth() const = 0;

    /**
     * Set yWidth attribute.
     * @param item unsigned
     */
    virtual void SetyWidth(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate yWidth attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateyWidth() = 0;

    /**
     * Get resolutionX attribute.
     * @return unsigned
     */
    virtual unsigned GetresolutionX() const = 0;

    /**
     * Get resolutionX attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionX() const = 0;

    /**
     * Set resolutionX attribute.
     * @param item unsigned
     */
    virtual void SetresolutionX(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate resolutionX attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionX() = 0;

    /**
     * Get resolutionY attribute.
     * @return unsigned
     */
    virtual unsigned GetresolutionY() const = 0;

    /**
     * Get resolutionY attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionY() const = 0;

    /**
     * Set resolutionY attribute.
     * @param item unsigned
     */
    virtual void SetresolutionY(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate resolutionY attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionY() = 0;

    /**
     * Get resolutionZ attribute.
     * @return unsigned
     */
    virtual unsigned GetresolutionZ() const = 0;

    /**
     * Get resolutionZ attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionZ() const = 0;

    /**
     * Set resolutionZ attribute.
     * @param item unsigned
     */
    virtual void SetresolutionZ(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate resolutionZ attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionZ() = 0;

    /**
     * Get resolutionP attribute.
     * @return int
     */
    virtual int GetresolutionP() const = 0;

    /**
     * Get resolutionP attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionP() const = 0;

    /**
     * Set resolutionP attribute.
     * @param item int
     */
    virtual void SetresolutionP(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate resolutionP attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionP() = 0;

    /**
     * Get resolutionS attribute.
     * @return int
     */
    virtual int GetresolutionS() const = 0;

    /**
     * Get resolutionS attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionS() const = 0;

    /**
     * Set resolutionS attribute.
     * @param item int
     */
    virtual void SetresolutionS(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate resolutionS attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionS() = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Device element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetDevice() const = 0;

    /**
     * Set Device element.
     * @param item const Mp7JrsTermUsePtr &
     */
    // Mandatory			
    virtual void SetDevice(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Gets or creates Mp7JrsNodePtr child elements of InkMediaInformationType_InputDevice_LocalType.
     * Currently this type contains one child element of type "Mp7JrsNodePtr".

     * <ul>
     * <li>Device</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_InputDevice_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_InputDevice_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsInkMediaInformationType_InputDevice_LocalType<br>
 * Located at: mds-2001.xsd, line 3757<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 3757.<br>
 */
class MP7JRS_EXPORT Mp7JrsInkMediaInformationType_InputDevice_LocalType :
        public IMp7JrsInkMediaInformationType_InputDevice_LocalType
{
    friend class Mp7JrsInkMediaInformationType_InputDevice_LocalTypeFactory; // constructs objects

public:
    /*
     * Get xWidth attribute.
     * @return unsigned
     */
    virtual unsigned GetxWidth() const;

    /*
     * Get xWidth attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistxWidth() const;

    /*
     * Set xWidth attribute.
     * @param item unsigned
     */
    virtual void SetxWidth(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate xWidth attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatexWidth();

    /*
     * Get yWidth attribute.
     * @return unsigned
     */
    virtual unsigned GetyWidth() const;

    /*
     * Get yWidth attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistyWidth() const;

    /*
     * Set yWidth attribute.
     * @param item unsigned
     */
    virtual void SetyWidth(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate yWidth attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateyWidth();

    /*
     * Get resolutionX attribute.
     * @return unsigned
     */
    virtual unsigned GetresolutionX() const;

    /*
     * Get resolutionX attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionX() const;

    /*
     * Set resolutionX attribute.
     * @param item unsigned
     */
    virtual void SetresolutionX(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate resolutionX attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionX();

    /*
     * Get resolutionY attribute.
     * @return unsigned
     */
    virtual unsigned GetresolutionY() const;

    /*
     * Get resolutionY attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionY() const;

    /*
     * Set resolutionY attribute.
     * @param item unsigned
     */
    virtual void SetresolutionY(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate resolutionY attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionY();

    /*
     * Get resolutionZ attribute.
     * @return unsigned
     */
    virtual unsigned GetresolutionZ() const;

    /*
     * Get resolutionZ attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionZ() const;

    /*
     * Set resolutionZ attribute.
     * @param item unsigned
     */
    virtual void SetresolutionZ(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate resolutionZ attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionZ();

    /*
     * Get resolutionP attribute.
     * @return int
     */
    virtual int GetresolutionP() const;

    /*
     * Get resolutionP attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionP() const;

    /*
     * Set resolutionP attribute.
     * @param item int
     */
    virtual void SetresolutionP(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate resolutionP attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionP();

    /*
     * Get resolutionS attribute.
     * @return int
     */
    virtual int GetresolutionS() const;

    /*
     * Get resolutionS attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistresolutionS() const;

    /*
     * Set resolutionS attribute.
     * @param item int
     */
    virtual void SetresolutionS(int item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate resolutionS attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateresolutionS();

        /* @name Sequence

         */
        //@{
    /*
     * Get Device element.
     * @return Mp7JrsTermUsePtr
     */
    virtual Mp7JrsTermUsePtr GetDevice() const;

    /*
     * Set Device element.
     * @param item const Mp7JrsTermUsePtr &
     */
    // Mandatory			
    virtual void SetDevice(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Gets or creates Mp7JrsNodePtr child elements of InkMediaInformationType_InputDevice_LocalType.
     * Currently this type contains one child element of type "Mp7JrsNodePtr".

     * <ul>
     * <li>Device</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_InputDevice_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsInkMediaInformationType_InputDevice_LocalType();

protected:
    Mp7JrsInkMediaInformationType_InputDevice_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    unsigned m_xWidth;
    bool m_xWidth_Exist;
    unsigned m_yWidth;
    bool m_yWidth_Exist;
    unsigned m_resolutionX;
    bool m_resolutionX_Exist;
    unsigned m_resolutionY;
    bool m_resolutionY_Exist;
    unsigned m_resolutionZ;
    bool m_resolutionZ_Exist;
    int m_resolutionP;
    bool m_resolutionP_Exist;
    int m_resolutionS;
    bool m_resolutionS_Exist;


    Mp7JrsTermUsePtr m_Device;

// no includefile for extension defined 
// file Mp7JrsInkMediaInformationType_InputDevice_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1013MP7JRSINKMEDIAINFORMATIONTYPE_INPUTDEVICE_LOCALTYPE_H

