/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1055MP7JRSINKSEGMENTTYPE_LOCALTYPE_H
#define _1055MP7JRSINKSEGMENTTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsInkSegmentType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsInkSegmentType_LocalType_ExtInclude.h


class IMp7JrsHandWritingRecogInformationType;
class IMp7JrsHandWritingRecogResultType;
class IMp7JrsInkSegmentType_LocalType;
typedef Mp7JrsPtr< IMp7JrsHandWritingRecogInformationType > Mp7JrsHandWritingRecogInformationPtr;
typedef Mp7JrsPtr< IMp7JrsHandWritingRecogResultType > Mp7JrsHandWritingRecogResultPtr;
typedef Mp7JrsPtr< IMp7JrsInkSegmentType_LocalType> Mp7JrsInkSegmentType_LocalPtr;

/** 
 * Generated interface IMp7JrsInkSegmentType_LocalType for class Mp7JrsInkSegmentType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsInkSegmentType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsInkSegmentType_LocalType();
    virtual ~IMp7JrsInkSegmentType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get HandWritingRecogInformation element.
     * @return Mp7JrsHandWritingRecogInformationPtr
     */
    virtual Mp7JrsHandWritingRecogInformationPtr GetHandWritingRecogInformation() const = 0;

    /**
     * Set HandWritingRecogInformation element.
     * @param item const Mp7JrsHandWritingRecogInformationPtr &
     */
    virtual void SetHandWritingRecogInformation(const Mp7JrsHandWritingRecogInformationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get HandWritingRecogResult element.
     * @return Mp7JrsHandWritingRecogResultPtr
     */
    virtual Mp7JrsHandWritingRecogResultPtr GetHandWritingRecogResult() const = 0;

    /**
     * Set HandWritingRecogResult element.
     * @param item const Mp7JrsHandWritingRecogResultPtr &
     */
    virtual void SetHandWritingRecogResult(const Mp7JrsHandWritingRecogResultPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsInkSegmentType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsInkSegmentType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsInkSegmentType_LocalType<br>
 * Defined in mds-2001.xsd, line 3722.<br>
 */
class MP7JRS_EXPORT Mp7JrsInkSegmentType_LocalType :
        public IMp7JrsInkSegmentType_LocalType
{
    friend class Mp7JrsInkSegmentType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get HandWritingRecogInformation element.
     * @return Mp7JrsHandWritingRecogInformationPtr
     */
    virtual Mp7JrsHandWritingRecogInformationPtr GetHandWritingRecogInformation() const;

    /*
     * Set HandWritingRecogInformation element.
     * @param item const Mp7JrsHandWritingRecogInformationPtr &
     */
    virtual void SetHandWritingRecogInformation(const Mp7JrsHandWritingRecogInformationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get HandWritingRecogResult element.
     * @return Mp7JrsHandWritingRecogResultPtr
     */
    virtual Mp7JrsHandWritingRecogResultPtr GetHandWritingRecogResult() const;

    /*
     * Set HandWritingRecogResult element.
     * @param item const Mp7JrsHandWritingRecogResultPtr &
     */
    virtual void SetHandWritingRecogResult(const Mp7JrsHandWritingRecogResultPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsInkSegmentType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsInkSegmentType_LocalType();

protected:
    Mp7JrsInkSegmentType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsHandWritingRecogInformationPtr m_HandWritingRecogInformation;
    Mp7JrsHandWritingRecogResultPtr m_HandWritingRecogResult;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsInkSegmentType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1055MP7JRSINKSEGMENTTYPE_LOCALTYPE_H

