/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1247MP7JRSMEDIATRANSCODINGHINTSTYPE_CODINGHINTS_LOCALTYPE_H
#define _1247MP7JRSMEDIATRANSCODINGHINTSTYPE_CODINGHINTS_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMediaTranscodingHintsType_CodingHints_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType_ExtInclude.h


class IMp7JrsMediaTranscodingHintsType_CodingHints_LocalType;
class IMp7JrsnonNegativeReal;
typedef Mp7JrsPtr< IMp7JrsMediaTranscodingHintsType_CodingHints_LocalType> Mp7JrsMediaTranscodingHintsType_CodingHints_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsnonNegativeReal > Mp7JrsnonNegativeRealPtr;

/** 
 * Generated interface IMp7JrsMediaTranscodingHintsType_CodingHints_LocalType for class Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType<br>
 * Located at: mds-2001.xsd, line 2383<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsMediaTranscodingHintsType_CodingHints_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMediaTranscodingHintsType_CodingHints_LocalType();
    virtual ~IMp7JrsMediaTranscodingHintsType_CodingHints_LocalType();
    /**
     * Get avgQuantScale attribute.
     * @return Mp7JrsnonNegativeRealPtr
     */
    virtual Mp7JrsnonNegativeRealPtr GetavgQuantScale() const = 0;

    /**
     * Get avgQuantScale attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistavgQuantScale() const = 0;

    /**
     * Set avgQuantScale attribute.
     * @param item const Mp7JrsnonNegativeRealPtr &
     */
    virtual void SetavgQuantScale(const Mp7JrsnonNegativeRealPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate avgQuantScale attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateavgQuantScale() = 0;

    /**
     * Get intraFrameDistance attribute.
     * @return unsigned
     */
    virtual unsigned GetintraFrameDistance() const = 0;

    /**
     * Get intraFrameDistance attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistintraFrameDistance() const = 0;

    /**
     * Set intraFrameDistance attribute.
     * @param item unsigned
     */
    virtual void SetintraFrameDistance(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate intraFrameDistance attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateintraFrameDistance() = 0;

    /**
     * Get anchorFrameDistance attribute.
     * @return unsigned
     */
    virtual unsigned GetanchorFrameDistance() const = 0;

    /**
     * Get anchorFrameDistance attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistanchorFrameDistance() const = 0;

    /**
     * Set anchorFrameDistance attribute.
     * @param item unsigned
     */
    virtual void SetanchorFrameDistance(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate anchorFrameDistance attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateanchorFrameDistance() = 0;

    /**
     * Gets or creates Mp7JrsNodePtr child elements of MediaTranscodingHintsType_CodingHints_LocalType.
     * Currently just supports rudimentary XPath expressions as MediaTranscodingHintsType_CodingHints_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType<br>
 * Located at: mds-2001.xsd, line 2383<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 2383.<br>
 */
class MP7JRS_EXPORT Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType :
        public IMp7JrsMediaTranscodingHintsType_CodingHints_LocalType
{
    friend class Mp7JrsMediaTranscodingHintsType_CodingHints_LocalTypeFactory; // constructs objects

public:
    /*
     * Get avgQuantScale attribute.
     * @return Mp7JrsnonNegativeRealPtr
     */
    virtual Mp7JrsnonNegativeRealPtr GetavgQuantScale() const;

    /*
     * Get avgQuantScale attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistavgQuantScale() const;

    /*
     * Set avgQuantScale attribute.
     * @param item const Mp7JrsnonNegativeRealPtr &
     */
    virtual void SetavgQuantScale(const Mp7JrsnonNegativeRealPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate avgQuantScale attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateavgQuantScale();

    /*
     * Get intraFrameDistance attribute.
     * @return unsigned
     */
    virtual unsigned GetintraFrameDistance() const;

    /*
     * Get intraFrameDistance attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistintraFrameDistance() const;

    /*
     * Set intraFrameDistance attribute.
     * @param item unsigned
     */
    virtual void SetintraFrameDistance(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate intraFrameDistance attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateintraFrameDistance();

    /*
     * Get anchorFrameDistance attribute.
     * @return unsigned
     */
    virtual unsigned GetanchorFrameDistance() const;

    /*
     * Get anchorFrameDistance attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistanchorFrameDistance() const;

    /*
     * Set anchorFrameDistance attribute.
     * @param item unsigned
     */
    virtual void SetanchorFrameDistance(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate anchorFrameDistance attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateanchorFrameDistance();

    /*
     * Gets or creates Mp7JrsNodePtr child elements of MediaTranscodingHintsType_CodingHints_LocalType.
     * Currently just supports rudimentary XPath expressions as MediaTranscodingHintsType_CodingHints_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType();

protected:
    Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsnonNegativeRealPtr m_avgQuantScale;
    bool m_avgQuantScale_Exist;
    unsigned m_intraFrameDistance;
    bool m_intraFrameDistance_Exist;
    unsigned m_anchorFrameDistance;
    bool m_anchorFrameDistance_Exist;



// no includefile for extension defined 
// file Mp7JrsMediaTranscodingHintsType_CodingHints_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1247MP7JRSMEDIATRANSCODINGHINTSTYPE_CODINGHINTS_LOCALTYPE_H

