/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1271MP7JRSMELODYSEQUENCETYPE_STARTINGNOTE_STARTINGPITCH_PITCHNOTE_LOCALTYPE_H
#define _1271MP7JRSMELODYSEQUENCETYPE_STARTINGNOTE_STARTINGPITCH_PITCHNOTE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType_ExtInclude.h


#include "Mp7JrsdegreeNoteType.h"
class IMp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType;
typedef Mp7JrsPtr< IMp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType> Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalPtr;

/** 
 * Generated interface IMp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType for class Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType<br>
 * Located at: audio-2001.xsd, line 863<br>
 * Classified: Class<br>
 * Derived from: degreeNoteType (Enumeration)<br>
 */
class MP7JRS_EXPORT IMp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType();
    virtual ~IMp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType();
    /**
     * Sets the content of Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType     * @param item Mp7JrsdegreeNoteType::Enumeration
     */
    virtual void SetContent(Mp7JrsdegreeNoteType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Retrieves the content of Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType 
     * @return Mp7JrsdegreeNoteType::Enumeration
     */
    virtual Mp7JrsdegreeNoteType::Enumeration GetContent() const = 0;

    /**
     * Get display attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getdisplay() const = 0;

    /**
     * Get display attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdisplay() const = 0;

    /**
     * Set display attribute.
     * @param item XMLCh *
     */
    virtual void Setdisplay(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate display attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedisplay() = 0;

    /**
     * Gets or creates Mp7JrsNodePtr child elements of MelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType.
     * Currently just supports rudimentary XPath expressions as MelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType<br>
 * Located at: audio-2001.xsd, line 863<br>
 * Classified: Class<br>
 * Derived from: degreeNoteType (Enumeration)<br>
 * Defined in audio-2001.xsd, line 863.<br>
 */
class MP7JRS_EXPORT Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType :
        public IMp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType
{
    friend class Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalTypeFactory; // constructs objects

public:
    /*
     * Sets the content of Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType     * @param item Mp7JrsdegreeNoteType::Enumeration
     */
    virtual void SetContent(Mp7JrsdegreeNoteType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Retrieves the content of Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType 
     * @return Mp7JrsdegreeNoteType::Enumeration
     */
    virtual Mp7JrsdegreeNoteType::Enumeration GetContent() const;

    /*
     * Get display attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getdisplay() const;

    /*
     * Get display attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existdisplay() const;

    /*
     * Set display attribute.
     * @param item XMLCh *
     */
    virtual void Setdisplay(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate display attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatedisplay();

    /*
     * Gets or creates Mp7JrsNodePtr child elements of MelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType.
     * Currently just supports rudimentary XPath expressions as MelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType();

protected:
    Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_display;
    bool m_display_Exist;

    // Base Enumeration
    Mp7JrsdegreeNoteType::Enumeration m_Base;


// no includefile for extension defined 
// file Mp7JrsMelodySequenceType_StartingNote_StartingPitch_PitchNote_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1271MP7JRSMELODYSEQUENCETYPE_STARTINGNOTE_STARTINGPITCH_PITCHNOTE_LOCALTYPE_H

