/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

#ifndef _1304MP7JRSMIXEDCOLLECTIONTYPE_DESCRIPTOR_COLLECTIONTYPEFACTORY_H
#define _1304MP7JRSMIXEDCOLLECTIONTYPE_DESCRIPTOR_COLLECTIONTYPEFACTORY_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsFactory.h"
#include "Mp7JrsPtr.h"
#include "Mp7JrsPtrTypes.h"

/*
 * Generated factory Mp7JrsMixedCollectionType_Descriptor_CollectionTypeFactory<br>
 * for class Mp7JrsMixedCollectionType_Descriptor_CollectionType:<br>
 * Located at: mds-2001.xsd, line 5330<br>
 * Abstract item type: DType<br>
 * Possible classes:<br>
 * \li AudioFundamentalFrequencyType (Class)<br>
 * \li AudioHarmonicityType (Class)<br>
 * \li AudioPowerType (Class)<br>
 * \li AudioSpectrumBasisType (Class)<br>
 * \li AudioSpectrumCentroidType (Class)<br>
 * \li AudioSpectrumEnvelopeType (Class)<br>
 * \li AudioSpectrumFlatnessType (Class)<br>
 * \li AudioSpectrumProjectionType (Class)<br>
 * \li AudioSpectrumSpreadType (Class)<br>
 * \li AudioSummaryComponentType (Class)<br>
 * \li AudioWaveformType (Class)<br>
 * \li BrowsingPreferencesType_PreferenceCondition_LocalType (Class)<br>
 * \li CameraMotionType (Class)<br>
 * \li ColorLayoutType (Class)<br>
 * \li ColorSamplingType (Class)<br>
 * \li ColorStructureType (Class)<br>
 * \li ContourShapeType (Class)<br>
 * \li DominantColorType (Class)<br>
 * \li EdgeHistogramType (Class)<br>
 * \li FaceRecognitionType (Class)<br>
 * \li GoFGoPColorType (Class)<br>
 * \li HarmonicSpectralCentroidType (Class)<br>
 * \li HarmonicSpectralDeviationType (Class)<br>
 * \li HarmonicSpectralSpreadType (Class)<br>
 * \li HarmonicSpectralVariationType (Class)<br>
 * \li HomogeneousTextureType (Class)<br>
 * \li LogAttackTimeType (Class)<br>
 * \li MatchingHintType (Class)<br>
 * \li MediaFormatType (Class)<br>
 * \li MediaIdentificationType (Class)<br>
 * \li MediaQualityType (Class)<br>
 * \li MediaSpaceMaskType (Class)<br>
 * \li MediaTranscodingHintsType (Class)<br>
 * \li MeterType (Class)<br>
 * \li MotionActivityType (Class)<br>
 * \li MotionTrajectoryType (Class)<br>
 * \li OrderedGroupDataSetMaskType (Class)<br>
 * \li ParametricMotionType (Class)<br>
 * \li PointOfViewType (Class)<br>
 * \li PreferenceConditionType (Class)<br>
 * \li RegionShapeType (Class)<br>
 * \li ScalableColorType (Class)<br>
 * \li SceneGraphMaskType (Class)<br>
 * \li Shape3DType (Class)<br>
 * \li SilenceType (Class)<br>
 * \li SoundModelStateHistogramType (Class)<br>
 * \li SourcePreferencesType_MediaFormat_LocalType (Class)<br>
 * \li SpatialMaskType (Class)<br>
 * \li SpatioTemporalMaskType (Class)<br>
 * \li SpectralCentroidType (Class)<br>
 * \li TemporalCentroidType (Class)<br>
 * \li TemporalMaskType (Class)<br>
 * \li TextualSummaryComponentType (Class)<br>
 * \li TextureBrowsingType (Class)<br>
 * \li VisualSummaryComponentType (Class)<br>
 */

class MP7JRS_EXPORT Mp7JrsMixedCollectionType_Descriptor_CollectionTypeFactory :
    public Mp7JrsFactory
{
public:
    Mp7JrsMixedCollectionType_Descriptor_CollectionTypeFactory();
    virtual ~Mp7JrsMixedCollectionType_Descriptor_CollectionTypeFactory();
	
    virtual const char * GetTypeName() const; // Formerly GetObjectType()
    virtual Mp7JrsNodePtr CreateObject();
};

#endif // _1304MP7JRSMIXEDCOLLECTIONTYPE_DESCRIPTOR_COLLECTIONTYPEFACTORY_H
