/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1553MP7JRSPERSONGROUPTYPE_LOCALTYPE_H
#define _1553MP7JRSPERSONGROUPTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsPersonGroupType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsPersonGroupType_LocalType_ExtInclude.h


class IMp7JrsPersonGroupType_LocalType;
class IMp7JrsPersonType;
class IMp7JrsReferenceType;
typedef Mp7JrsPtr< IMp7JrsPersonGroupType_LocalType> Mp7JrsPersonGroupType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsPersonType > Mp7JrsPersonPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;

/** 
 * Generated interface IMp7JrsPersonGroupType_LocalType for class Mp7JrsPersonGroupType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsPersonGroupType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsPersonGroupType_LocalType();
    virtual ~IMp7JrsPersonGroupType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get Member element.
     * @return Mp7JrsPersonPtr
     */
    virtual Mp7JrsPersonPtr GetMember() const = 0;

    /**
     * Set Member element.
     * @param item const Mp7JrsPersonPtr &
     */
    virtual void SetMember(const Mp7JrsPersonPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MemberRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetMemberRef() const = 0;

    /**
     * Set MemberRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetMemberRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsPersonGroupType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsPersonGroupType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsPersonGroupType_LocalType<br>
 * Defined in mds-2001.xsd, line 1743.<br>
 */
class MP7JRS_EXPORT Mp7JrsPersonGroupType_LocalType :
        public IMp7JrsPersonGroupType_LocalType
{
    friend class Mp7JrsPersonGroupType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get Member element.
     * @return Mp7JrsPersonPtr
     */
    virtual Mp7JrsPersonPtr GetMember() const;

    /*
     * Set Member element.
     * @param item const Mp7JrsPersonPtr &
     */
    virtual void SetMember(const Mp7JrsPersonPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MemberRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetMemberRef() const;

    /*
     * Set MemberRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetMemberRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsPersonGroupType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsPersonGroupType_LocalType();

protected:
    Mp7JrsPersonGroupType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsPersonPtr m_Member;
    Mp7JrsReferencePtr m_MemberRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsPersonGroupType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1553MP7JRSPERSONGROUPTYPE_LOCALTYPE_H

