/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1739MP7JRSSCALABLECOLORTYPE_H
#define _1739MP7JRSSCALABLECOLORTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsScalableColorTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsScalableColorType_ExtInclude.h


#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
#include "Mp7JrsScalableColorType_numOfBitplanesDiscarded_LocalType.h"
#include "Mp7JrsScalableColorType_numOfCoeff_LocalType.h"
#include "Mp7JrsVisualDType.h"
class IMp7JrsintegerVector;
class IMp7JrsScalableColorType;
class IMp7JrsVisualDType;
typedef Mp7JrsPtr< IMp7JrsintegerVector > Mp7JrsintegerVectorPtr;
typedef Mp7JrsPtr< IMp7JrsScalableColorType> Mp7JrsScalableColorPtr;
typedef Mp7JrsPtr< IMp7JrsVisualDType > Mp7JrsVisualDPtr;

/** 
 * Generated interface IMp7JrsScalableColorType for class Mp7JrsScalableColorType<br>
 * Located at: visual-2001.with.net.workaround.xsd, line 340<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsScalableColorType 
 :
        public IMp7JrsVisualDType
{
public:
    // TODO: make these protected?
    IMp7JrsScalableColorType();
    virtual ~IMp7JrsScalableColorType();
    /**
     * Get numOfCoeff attribute.
     * @return Mp7JrsScalableColorType_numOfCoeff_LocalType::Enumeration
     */
    virtual Mp7JrsScalableColorType_numOfCoeff_LocalType::Enumeration GetnumOfCoeff() const = 0;

    /**
     * Set numOfCoeff attribute.
     * @param item Mp7JrsScalableColorType_numOfCoeff_LocalType::Enumeration
     */
    // Mandatory
    virtual void SetnumOfCoeff(Mp7JrsScalableColorType_numOfCoeff_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get numOfBitplanesDiscarded attribute.
     * @return Mp7JrsScalableColorType_numOfBitplanesDiscarded_LocalType::Enumeration
     */
    virtual Mp7JrsScalableColorType_numOfBitplanesDiscarded_LocalType::Enumeration GetnumOfBitplanesDiscarded() const = 0;

    /**
     * Set numOfBitplanesDiscarded attribute.
     * @param item Mp7JrsScalableColorType_numOfBitplanesDiscarded_LocalType::Enumeration
     */
    // Mandatory
    virtual void SetnumOfBitplanesDiscarded(Mp7JrsScalableColorType_numOfBitplanesDiscarded_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        /** @name Sequence

         */
        //@{
    /**
     * Get Coeff element.
     * @return Mp7JrsintegerVectorPtr
     */
    virtual Mp7JrsintegerVectorPtr GetCoeff() const = 0;

    /**
     * Set Coeff element.
     * @param item const Mp7JrsintegerVectorPtr &
     */
    // Mandatory collection
    virtual void SetCoeff(const Mp7JrsintegerVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Gets or creates Mp7JrsNodePtr child elements of ScalableColorType.
     * Currently just supports rudimentary XPath expressions as ScalableColorType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsScalableColorType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsScalableColorType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsScalableColorType<br>
 * Located at: visual-2001.with.net.workaround.xsd, line 340<br>
 * Classified: Class<br>
 * Derived from: VisualDType (Class)<br>
 * Defined in visual-2001.with.net.workaround.xsd, line 340.<br>
 */
class MP7JRS_EXPORT Mp7JrsScalableColorType :
        public IMp7JrsScalableColorType
{
    friend class Mp7JrsScalableColorTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsScalableColorType
     
     * @return Mp7JrsPtr< Mp7JrsVisualDType >
     */
    virtual Mp7JrsPtr< Mp7JrsVisualDType > GetBase() const;
    /*
     * Get numOfCoeff attribute.
     * @return Mp7JrsScalableColorType_numOfCoeff_LocalType::Enumeration
     */
    virtual Mp7JrsScalableColorType_numOfCoeff_LocalType::Enumeration GetnumOfCoeff() const;

    /*
     * Set numOfCoeff attribute.
     * @param item Mp7JrsScalableColorType_numOfCoeff_LocalType::Enumeration
     */
    // Mandatory
    virtual void SetnumOfCoeff(Mp7JrsScalableColorType_numOfCoeff_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get numOfBitplanesDiscarded attribute.
     * @return Mp7JrsScalableColorType_numOfBitplanesDiscarded_LocalType::Enumeration
     */
    virtual Mp7JrsScalableColorType_numOfBitplanesDiscarded_LocalType::Enumeration GetnumOfBitplanesDiscarded() const;

    /*
     * Set numOfBitplanesDiscarded attribute.
     * @param item Mp7JrsScalableColorType_numOfBitplanesDiscarded_LocalType::Enumeration
     */
    // Mandatory
    virtual void SetnumOfBitplanesDiscarded(Mp7JrsScalableColorType_numOfBitplanesDiscarded_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        /* @name Sequence

         */
        //@{
    /*
     * Get Coeff element.
     * @return Mp7JrsintegerVectorPtr
     */
    virtual Mp7JrsintegerVectorPtr GetCoeff() const;

    /*
     * Set Coeff element.
     * @param item const Mp7JrsintegerVectorPtr &
     */
    // Mandatory collection
    virtual void SetCoeff(const Mp7JrsintegerVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Gets or creates Mp7JrsNodePtr child elements of ScalableColorType.
     * Currently just supports rudimentary XPath expressions as ScalableColorType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsScalableColorType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsScalableColorType();

protected:
    Mp7JrsScalableColorType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsScalableColorType_numOfCoeff_LocalType::Enumeration m_numOfCoeff;
    Mp7JrsScalableColorType_numOfBitplanesDiscarded_LocalType::Enumeration m_numOfBitplanesDiscarded;

    // Base Class
    Mp7JrsPtr< Mp7JrsVisualDType > m_Base;

    Mp7JrsintegerVectorPtr m_Coeff;

// no includefile for extension defined 
// file Mp7JrsScalableColorType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1739MP7JRSSCALABLECOLORTYPE_H

