/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1891MP7JRSSHOTEDITINGTEMPORALDECOMPOSITIONTYPE_LOCALTYPE_H
#define _1891MP7JRSSHOTEDITINGTEMPORALDECOMPOSITIONTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsShotEditingTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsShotEditingTemporalDecompositionType_LocalType_ExtInclude.h


class IMp7JrsCompositionShotType;
class IMp7JrsCompositionTransitionType;
class IMp7JrsReferenceType;
class IMp7JrsShotEditingTemporalDecompositionType_LocalType;
typedef Mp7JrsPtr< IMp7JrsCompositionShotType > Mp7JrsCompositionShotPtr;
typedef Mp7JrsPtr< IMp7JrsCompositionTransitionType > Mp7JrsCompositionTransitionPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsShotEditingTemporalDecompositionType_LocalType> Mp7JrsShotEditingTemporalDecompositionType_LocalPtr;

/** 
 * Generated interface IMp7JrsShotEditingTemporalDecompositionType_LocalType for class Mp7JrsShotEditingTemporalDecompositionType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsShotEditingTemporalDecompositionType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsShotEditingTemporalDecompositionType_LocalType();
    virtual ~IMp7JrsShotEditingTemporalDecompositionType_LocalType();
        /** @name Sequence

         */
        //@{
        /** @name Choice

         */
        //@{
        /** @name Choice

         */
        //@{
    /**
     * Get CompositionShot element.
     * @return Mp7JrsCompositionShotPtr
     */
    virtual Mp7JrsCompositionShotPtr GetCompositionShot() const = 0;

    /**
     * Set CompositionShot element.
     * @param item const Mp7JrsCompositionShotPtr &
     */
    // Mandatory			
    virtual void SetCompositionShot(const Mp7JrsCompositionShotPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CompositionShotRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetCompositionShotRef() const = 0;

    /**
     * Set CompositionShotRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetCompositionShotRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Choice

         */
        //@{
    /**
     * Get CompositionTransition element.
     * @return Mp7JrsCompositionTransitionPtr
     */
    virtual Mp7JrsCompositionTransitionPtr GetCompositionTransition() const = 0;

    /**
     * Set CompositionTransition element.
     * @param item const Mp7JrsCompositionTransitionPtr &
     */
    // Mandatory			
    virtual void SetCompositionTransition(const Mp7JrsCompositionTransitionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CompositionTransitionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetCompositionTransitionRef() const = 0;

    /**
     * Set CompositionTransitionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetCompositionTransitionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        //@}
        //@}
// no includefile for extension defined 
// file Mp7JrsShotEditingTemporalDecompositionType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsShotEditingTemporalDecompositionType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsShotEditingTemporalDecompositionType_LocalType<br>
 * Defined in mds-2001.xsd, line 4045.<br>
 */
class MP7JRS_EXPORT Mp7JrsShotEditingTemporalDecompositionType_LocalType :
        public IMp7JrsShotEditingTemporalDecompositionType_LocalType
{
    friend class Mp7JrsShotEditingTemporalDecompositionType_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
        /* @name Choice

         */
        //@{
        /* @name Choice

         */
        //@{
    /*
     * Get CompositionShot element.
     * @return Mp7JrsCompositionShotPtr
     */
    virtual Mp7JrsCompositionShotPtr GetCompositionShot() const;

    /*
     * Set CompositionShot element.
     * @param item const Mp7JrsCompositionShotPtr &
     */
    // Mandatory			
    virtual void SetCompositionShot(const Mp7JrsCompositionShotPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CompositionShotRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetCompositionShotRef() const;

    /*
     * Set CompositionShotRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetCompositionShotRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Choice

         */
        //@{
    /*
     * Get CompositionTransition element.
     * @return Mp7JrsCompositionTransitionPtr
     */
    virtual Mp7JrsCompositionTransitionPtr GetCompositionTransition() const;

    /*
     * Set CompositionTransition element.
     * @param item const Mp7JrsCompositionTransitionPtr &
     */
    // Mandatory			
    virtual void SetCompositionTransition(const Mp7JrsCompositionTransitionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CompositionTransitionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetCompositionTransitionRef() const;

    /*
     * Set CompositionTransitionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetCompositionTransitionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        //@}
        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsShotEditingTemporalDecompositionType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsShotEditingTemporalDecompositionType_LocalType();

protected:
    Mp7JrsShotEditingTemporalDecompositionType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
// DefinionChoice
    Mp7JrsCompositionShotPtr m_CompositionShot;
    Mp7JrsReferencePtr m_CompositionShotRef;
// End DefinionChoice
// DefinionChoice
    Mp7JrsCompositionTransitionPtr m_CompositionTransition;
    Mp7JrsReferencePtr m_CompositionTransitionRef;
// End DefinionChoice
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsShotEditingTemporalDecompositionType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1891MP7JRSSHOTEDITINGTEMPORALDECOMPOSITIONTYPE_LOCALTYPE_H

