/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1967MP7JRSSPACEFREQUENCYGRAPHTYPE_LOCALTYPE_H
#define _1967MP7JRSSPACEFREQUENCYGRAPHTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSpaceFrequencyGraphType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyGraphType_LocalType_ExtInclude.h


class IMp7JrsReferenceType;
class IMp7JrsSpaceFrequencyGraphType;
class IMp7JrsSpaceFrequencyGraphType_LocalType;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsSpaceFrequencyGraphType > Mp7JrsSpaceFrequencyGraphPtr;
typedef Mp7JrsPtr< IMp7JrsSpaceFrequencyGraphType_LocalType> Mp7JrsSpaceFrequencyGraphType_LocalPtr;

/** 
 * Generated interface IMp7JrsSpaceFrequencyGraphType_LocalType for class Mp7JrsSpaceFrequencyGraphType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsSpaceFrequencyGraphType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSpaceFrequencyGraphType_LocalType();
    virtual ~IMp7JrsSpaceFrequencyGraphType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get SpaceChild element.
     * @return Mp7JrsSpaceFrequencyGraphPtr
     */
    virtual Mp7JrsSpaceFrequencyGraphPtr GetSpaceChild() const = 0;

    /**
     * Set SpaceChild element.
     * @param item const Mp7JrsSpaceFrequencyGraphPtr &
     */
    virtual void SetSpaceChild(const Mp7JrsSpaceFrequencyGraphPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SpaceChildRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetSpaceChildRef() const = 0;

    /**
     * Set SpaceChildRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetSpaceChildRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyGraphType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyGraphType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSpaceFrequencyGraphType_LocalType<br>
 * Defined in mds-2001.xsd, line 5084.<br>
 */
class MP7JRS_EXPORT Mp7JrsSpaceFrequencyGraphType_LocalType :
        public IMp7JrsSpaceFrequencyGraphType_LocalType
{
    friend class Mp7JrsSpaceFrequencyGraphType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get SpaceChild element.
     * @return Mp7JrsSpaceFrequencyGraphPtr
     */
    virtual Mp7JrsSpaceFrequencyGraphPtr GetSpaceChild() const;

    /*
     * Set SpaceChild element.
     * @param item const Mp7JrsSpaceFrequencyGraphPtr &
     */
    virtual void SetSpaceChild(const Mp7JrsSpaceFrequencyGraphPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SpaceChildRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetSpaceChildRef() const;

    /*
     * Set SpaceChildRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetSpaceChildRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyGraphType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSpaceFrequencyGraphType_LocalType();

protected:
    Mp7JrsSpaceFrequencyGraphType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsSpaceFrequencyGraphPtr m_SpaceChild;
    Mp7JrsReferencePtr m_SpaceChildRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyGraphType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1967MP7JRSSPACEFREQUENCYGRAPHTYPE_LOCALTYPE_H

