/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2011MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_LOCALCOORDINATESYSTEM_LOCALTYPE1_H
#define _2011MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_LOCALCOORDINATESYSTEM_LOCALTYPE1_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1_ExtInclude.h


class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionType;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionType0 > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1> Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local1Ptr;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionType > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr;

/** 
 * Generated interface IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1 for class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1<br>
 * Located at: visual-2001.with.net.workaround.xsd, line 117<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1();
    virtual ~IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1();
    /**
     * Get name attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getname() const = 0;

    /**
     * Set name attribute.
     * @param item XMLCh *
     */
    // Mandatory
    virtual void Setname(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get dataSet attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetdataSet() const = 0;

    /**
     * Get dataSet attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistdataSet() const = 0;

    /**
     * Set dataSet attribute.
     * @param item XMLCh *
     */
    virtual void SetdataSet(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate dataSet attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatedataSet() = 0;

        /** @name Sequence

         */
        //@{
        /** @name Choice

         */
        //@{
    /**
     * Get Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType() const = 0;

    /**
     * Set Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0() const = 0;

    /**
     * Set Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr &
     */
    // Mandatory collection
    virtual void SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get MappingFunct element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr GetMappingFunct() const = 0;

    /**
     * Set MappingFunct element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetMappingFunct(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Gets or creates Mp7JrsNodePtr child elements of Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1.
     * Currently this type contains 5 child elements of type "Mp7JrsNodePtr".

     * <ul>
     * <li>Pixel</li>
     * <li>CoordPoint</li>
     * <li>CurrPixel</li>
     * <li>SrcPixel</li>
     * <li>MappingFunct</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1<br>
 * Located at: visual-2001.with.net.workaround.xsd, line 117<br>
 * Classified: Class<br>
 * Defined in visual-2001.with.net.workaround.xsd, line 117.<br>
 */
class MP7JRS_EXPORT Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1 :
        public IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1
{
    friend class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1Factory; // constructs objects

public:
    /*
     * Get name attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getname() const;

    /*
     * Set name attribute.
     * @param item XMLCh *
     */
    // Mandatory
    virtual void Setname(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get dataSet attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetdataSet() const;

    /*
     * Get dataSet attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistdataSet() const;

    /*
     * Set dataSet attribute.
     * @param item XMLCh *
     */
    virtual void SetdataSet(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate dataSet attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatedataSet();

        /* @name Sequence

         */
        //@{
        /* @name Choice

         */
        //@{
    /*
     * Get Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType() const;

    /*
     * Set Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr GetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0() const;

    /*
     * Set Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr &
     */
    // Mandatory collection
    virtual void SetSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get MappingFunct element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr GetMappingFunct() const;

    /*
     * Set MappingFunct element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetMappingFunct(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Gets or creates Mp7JrsNodePtr child elements of Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1.
     * Currently this type contains 5 child elements of type "Mp7JrsNodePtr".

     * <ul>
     * <li>Pixel</li>
     * <li>CoordPoint</li>
     * <li>CurrPixel</li>
     * <li>SrcPixel</li>
     * <li>MappingFunct</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1();

protected:
    Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_name;
    XMLCh * m_dataSet;
    bool m_dataSet_Exist;


// DefinionChoice
    Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CollectionPtr m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType;
    Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Collection0Ptr m_Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0;
// End DefinionChoice
    Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_MappingFunct_CollectionPtr m_MappingFunct;

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType1_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2011MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_LOCALCOORDINATESYSTEM_LOCALTYPE1_H

