/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2033MP7JRSSPATIOTEMPORALLOCATORTYPE_LOCALTYPE_H
#define _2033MP7JRSSPATIOTEMPORALLOCATORTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSpatioTemporalLocatorType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsSpatioTemporalLocatorType_LocalType_ExtInclude.h


class IMp7JrsFigureTrajectoryType;
class IMp7JrsMediaTimeType;
class IMp7JrsParameterTrajectoryType;
class IMp7JrsSpatioTemporalLocatorType_LocalType;
typedef Mp7JrsPtr< IMp7JrsFigureTrajectoryType > Mp7JrsFigureTrajectoryPtr;
typedef Mp7JrsPtr< IMp7JrsMediaTimeType > Mp7JrsMediaTimePtr;
typedef Mp7JrsPtr< IMp7JrsParameterTrajectoryType > Mp7JrsParameterTrajectoryPtr;
typedef Mp7JrsPtr< IMp7JrsSpatioTemporalLocatorType_LocalType> Mp7JrsSpatioTemporalLocatorType_LocalPtr;

/** 
 * Generated interface IMp7JrsSpatioTemporalLocatorType_LocalType for class Mp7JrsSpatioTemporalLocatorType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsSpatioTemporalLocatorType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSpatioTemporalLocatorType_LocalType();
    virtual ~IMp7JrsSpatioTemporalLocatorType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get FigureTrajectory element.
     * @return Mp7JrsFigureTrajectoryPtr
     */
    virtual Mp7JrsFigureTrajectoryPtr GetFigureTrajectory() const = 0;

    /**
     * Set FigureTrajectory element.
     * @param item const Mp7JrsFigureTrajectoryPtr &
     */
    // Mandatory			
    virtual void SetFigureTrajectory(const Mp7JrsFigureTrajectoryPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ParameterTrajectory element.
     * @return Mp7JrsParameterTrajectoryPtr
     */
    virtual Mp7JrsParameterTrajectoryPtr GetParameterTrajectory() const = 0;

    /**
     * Set ParameterTrajectory element.
     * @param item const Mp7JrsParameterTrajectoryPtr &
     */
    // Mandatory			
    virtual void SetParameterTrajectory(const Mp7JrsParameterTrajectoryPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MediaTime element.
     * @return Mp7JrsMediaTimePtr
     */
    virtual Mp7JrsMediaTimePtr GetMediaTime() const = 0;

    /**
     * Set MediaTime element.
     * @param item const Mp7JrsMediaTimePtr &
     */
    // Mandatory			
    virtual void SetMediaTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSpatioTemporalLocatorType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSpatioTemporalLocatorType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSpatioTemporalLocatorType_LocalType<br>
 * Defined in visual-2001.with.net.workaround.xsd, line 1170.<br>
 */
class MP7JRS_EXPORT Mp7JrsSpatioTemporalLocatorType_LocalType :
        public IMp7JrsSpatioTemporalLocatorType_LocalType
{
    friend class Mp7JrsSpatioTemporalLocatorType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get FigureTrajectory element.
     * @return Mp7JrsFigureTrajectoryPtr
     */
    virtual Mp7JrsFigureTrajectoryPtr GetFigureTrajectory() const;

    /*
     * Set FigureTrajectory element.
     * @param item const Mp7JrsFigureTrajectoryPtr &
     */
    // Mandatory			
    virtual void SetFigureTrajectory(const Mp7JrsFigureTrajectoryPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ParameterTrajectory element.
     * @return Mp7JrsParameterTrajectoryPtr
     */
    virtual Mp7JrsParameterTrajectoryPtr GetParameterTrajectory() const;

    /*
     * Set ParameterTrajectory element.
     * @param item const Mp7JrsParameterTrajectoryPtr &
     */
    // Mandatory			
    virtual void SetParameterTrajectory(const Mp7JrsParameterTrajectoryPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MediaTime element.
     * @return Mp7JrsMediaTimePtr
     */
    virtual Mp7JrsMediaTimePtr GetMediaTime() const;

    /*
     * Set MediaTime element.
     * @param item const Mp7JrsMediaTimePtr &
     */
    // Mandatory			
    virtual void SetMediaTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSpatioTemporalLocatorType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSpatioTemporalLocatorType_LocalType();

protected:
    Mp7JrsSpatioTemporalLocatorType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsFigureTrajectoryPtr m_FigureTrajectory;
    Mp7JrsParameterTrajectoryPtr m_ParameterTrajectory;
    Mp7JrsMediaTimePtr m_MediaTime;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsSpatioTemporalLocatorType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2033MP7JRSSPATIOTEMPORALLOCATORTYPE_LOCALTYPE_H

