/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2221MP7JRSSUMMARYTHEMELISTTYPE_SUMMARYTHEME_LOCALTYPE_H
#define _2221MP7JRSSUMMARYTHEMELISTTYPE_SUMMARYTHEME_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSummaryThemeListType_SummaryTheme_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsSummaryThemeListType_SummaryTheme_LocalType_ExtInclude.h


#include "Mp7JrsphoneticAlphabetType.h"
#include "Mp7JrsTextualBaseType.h"
#include "Mp7JrsTextualType.h"
class IMp7JrsSummaryThemeListType_SummaryTheme_LocalType;
class IMp7JrsTextualBaseType_phoneticTranscription_CollectionType;
class IMp7JrsTextualType;
typedef Mp7JrsPtr< IMp7JrsSummaryThemeListType_SummaryTheme_LocalType> Mp7JrsSummaryThemeListType_SummaryTheme_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsTextualBaseType_phoneticTranscription_CollectionType > Mp7JrsTextualBaseType_phoneticTranscription_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsTextualType > Mp7JrsTextualPtr;

/** 
 * Generated interface IMp7JrsSummaryThemeListType_SummaryTheme_LocalType for class Mp7JrsSummaryThemeListType_SummaryTheme_LocalType<br>
 * Located at: mds-2001.xsd, line 4529<br>
 * Classified: Class<br>
 * Derived from: TextualType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsSummaryThemeListType_SummaryTheme_LocalType 
 :
        public IMp7JrsTextualType
{
public:
    // TODO: make these protected?
    IMp7JrsSummaryThemeListType_SummaryTheme_LocalType();
    virtual ~IMp7JrsSummaryThemeListType_SummaryTheme_LocalType();
    /**
     * Sets the content of Mp7JrsTextualBaseType<br>
     * (Inherited from Mp7JrsTextualBaseType)
     * @param item XMLCh *
     */
    virtual void SetContent(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Retrieves the content of Mp7JrsTextualBaseType 
<br>
     * (Inherited from Mp7JrsTextualBaseType)
     * @return XMLCh *
     */
    virtual XMLCh * GetContent() const = 0;

    /**
     * Get id attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const = 0;

    /**
     * Set id attribute.
     * @param item XMLCh *
     */
    // Mandatory
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get parentID attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetparentID() const = 0;

    /**
     * Get parentID attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistparentID() const = 0;

    /**
     * Set parentID attribute.
     * @param item XMLCh *
     */
    virtual void SetparentID(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate parentID attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateparentID() = 0;

    /**
     * Get lang attribute.
<br>
     * (Inherited from Mp7JrsTextualBaseType)
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const = 0;

    /**
     * Get lang attribute validity information.
     * (Inherited from Mp7JrsTextualBaseType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const = 0;

    /**
     * Set lang attribute.
<br>
     * (Inherited from Mp7JrsTextualBaseType)
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate lang attribute.
     * (Inherited from Mp7JrsTextualBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang() = 0;

    /**
     * Get phoneticTranscription attribute.
<br>
     * (Inherited from Mp7JrsTextualBaseType)
     * @return Mp7JrsTextualBaseType_phoneticTranscription_CollectionPtr
     */
    virtual Mp7JrsTextualBaseType_phoneticTranscription_CollectionPtr GetphoneticTranscription() const = 0;

    /**
     * Get phoneticTranscription attribute validity information.
     * (Inherited from Mp7JrsTextualBaseType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistphoneticTranscription() const = 0;

    /**
     * Set phoneticTranscription attribute.
<br>
     * (Inherited from Mp7JrsTextualBaseType)
     * @param item const Mp7JrsTextualBaseType_phoneticTranscription_CollectionPtr &
     */
    virtual void SetphoneticTranscription(const Mp7JrsTextualBaseType_phoneticTranscription_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate phoneticTranscription attribute.
     * (Inherited from Mp7JrsTextualBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatephoneticTranscription() = 0;

    /**
     * Get phoneticAlphabet attribute.
<br>
     * (Inherited from Mp7JrsTextualBaseType)
     * @return Mp7JrsphoneticAlphabetType::Enumeration
     */
    virtual Mp7JrsphoneticAlphabetType::Enumeration GetphoneticAlphabet() const = 0;

    /**
     * Get phoneticAlphabet attribute validity information.
     * (Inherited from Mp7JrsTextualBaseType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistphoneticAlphabet() const = 0;

    /**
     * Set phoneticAlphabet attribute.
<br>
     * (Inherited from Mp7JrsTextualBaseType)
     * @param item Mp7JrsphoneticAlphabetType::Enumeration
     */
    virtual void SetphoneticAlphabet(Mp7JrsphoneticAlphabetType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate phoneticAlphabet attribute.
     * (Inherited from Mp7JrsTextualBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatephoneticAlphabet() = 0;

    /**
     * Gets or creates Mp7JrsNodePtr child elements of SummaryThemeListType_SummaryTheme_LocalType.
     * Currently just supports rudimentary XPath expressions as SummaryThemeListType_SummaryTheme_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsSummaryThemeListType_SummaryTheme_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSummaryThemeListType_SummaryTheme_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSummaryThemeListType_SummaryTheme_LocalType<br>
 * Located at: mds-2001.xsd, line 4529<br>
 * Classified: Class<br>
 * Derived from: TextualType (Class)<br>
 * Defined in mds-2001.xsd, line 4529.<br>
 */
class MP7JRS_EXPORT Mp7JrsSummaryThemeListType_SummaryTheme_LocalType :
        public IMp7JrsSummaryThemeListType_SummaryTheme_LocalType
{
    friend class Mp7JrsSummaryThemeListType_SummaryTheme_LocalTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsSummaryThemeListType_SummaryTheme_LocalType
     
     * @return Mp7JrsPtr< Mp7JrsTextualType >
     */
    virtual Mp7JrsPtr< Mp7JrsTextualType > GetBase() const;
    /*
     * Sets the content of Mp7JrsTextualBaseType<br>
     * (Inherited from Mp7JrsTextualBaseType)
     * @param item XMLCh *
     */
    virtual void SetContent(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Retrieves the content of Mp7JrsTextualBaseType 
<br>
     * (Inherited from Mp7JrsTextualBaseType)
     * @return XMLCh *
     */
    virtual XMLCh * GetContent() const;

    /*
     * Get id attribute.
     * @return XMLCh *
     */
    virtual XMLCh * Getid() const;

    /*
     * Set id attribute.
     * @param item XMLCh *
     */
    // Mandatory
    virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get parentID attribute.
     * @return XMLCh *
     */
    virtual XMLCh * GetparentID() const;

    /*
     * Get parentID attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistparentID() const;

    /*
     * Set parentID attribute.
     * @param item XMLCh *
     */
    virtual void SetparentID(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate parentID attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateparentID();

    /*
     * Get lang attribute.
<br>
     * (Inherited from Mp7JrsTextualBaseType)
     * @return XMLCh *
     */
    virtual XMLCh * Getlang() const;

    /*
     * Get lang attribute validity information.
     * (Inherited from Mp7JrsTextualBaseType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existlang() const;

    /*
     * Set lang attribute.
<br>
     * (Inherited from Mp7JrsTextualBaseType)
     * @param item XMLCh *
     */
    virtual void Setlang(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate lang attribute.
     * (Inherited from Mp7JrsTextualBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatelang();

    /*
     * Get phoneticTranscription attribute.
<br>
     * (Inherited from Mp7JrsTextualBaseType)
     * @return Mp7JrsTextualBaseType_phoneticTranscription_CollectionPtr
     */
    virtual Mp7JrsTextualBaseType_phoneticTranscription_CollectionPtr GetphoneticTranscription() const;

    /*
     * Get phoneticTranscription attribute validity information.
     * (Inherited from Mp7JrsTextualBaseType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistphoneticTranscription() const;

    /*
     * Set phoneticTranscription attribute.
<br>
     * (Inherited from Mp7JrsTextualBaseType)
     * @param item const Mp7JrsTextualBaseType_phoneticTranscription_CollectionPtr &
     */
    virtual void SetphoneticTranscription(const Mp7JrsTextualBaseType_phoneticTranscription_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate phoneticTranscription attribute.
     * (Inherited from Mp7JrsTextualBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatephoneticTranscription();

    /*
     * Get phoneticAlphabet attribute.
<br>
     * (Inherited from Mp7JrsTextualBaseType)
     * @return Mp7JrsphoneticAlphabetType::Enumeration
     */
    virtual Mp7JrsphoneticAlphabetType::Enumeration GetphoneticAlphabet() const;

    /*
     * Get phoneticAlphabet attribute validity information.
     * (Inherited from Mp7JrsTextualBaseType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistphoneticAlphabet() const;

    /*
     * Set phoneticAlphabet attribute.
<br>
     * (Inherited from Mp7JrsTextualBaseType)
     * @param item Mp7JrsphoneticAlphabetType::Enumeration
     */
    virtual void SetphoneticAlphabet(Mp7JrsphoneticAlphabetType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate phoneticAlphabet attribute.
     * (Inherited from Mp7JrsTextualBaseType)
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidatephoneticAlphabet();

    /*
     * Gets or creates Mp7JrsNodePtr child elements of SummaryThemeListType_SummaryTheme_LocalType.
     * Currently just supports rudimentary XPath expressions as SummaryThemeListType_SummaryTheme_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSummaryThemeListType_SummaryTheme_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSummaryThemeListType_SummaryTheme_LocalType();

protected:
    Mp7JrsSummaryThemeListType_SummaryTheme_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    XMLCh * m_id;
    XMLCh * m_parentID;
    bool m_parentID_Exist;

    // Base Class
    Mp7JrsPtr< Mp7JrsTextualType > m_Base;


// no includefile for extension defined 
// file Mp7JrsSummaryThemeListType_SummaryTheme_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2221MP7JRSSUMMARYTHEMELISTTYPE_SUMMARYTHEME_LOCALTYPE_H

