/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2235MP7JRSTEMPORALINTERPOLATIONTYPE_INTERPOLATIONFUNCTIONS_KEYVALUE_LOCALTYPE_H
#define _2235MP7JRSTEMPORALINTERPOLATIONTYPE_INTERPOLATIONFUNCTIONS_KEYVALUE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType_ExtInclude.h


#include "Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType.h"
class IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType;
typedef Mp7JrsPtr< IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType> Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalPtr;

/** 
 * Generated interface IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType for class Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType<br>
 * Located at: visual-2001.with.net.workaround.xsd, line 216<br>
 * Classified: Class<br>
 * Derived from: float (Value)<br>
 */
class MP7JRS_EXPORT IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType();
    virtual ~IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType();
    /**
     * Sets the content of Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType     * @param item float
     */
    virtual void SetContent(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Retrieves the content of Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType 
     * @return float
     */
    virtual float GetContent() const = 0;

    /**
     * Get type attribute.
     * @return Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::Enumeration
     */
    virtual Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::Enumeration Gettype() const = 0;

    /**
     * Get type attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtype() const = 0;

    /**
     * Set type attribute.
     * @param item Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::Enumeration
     */
    virtual void Settype(Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate type attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetype() = 0;

    /**
     * Get param attribute.
     * @return float
     */
    virtual float Getparam() const = 0;

    /**
     * Get param attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existparam() const = 0;

    /**
     * Set param attribute.
     * @param item float
     */
    virtual void Setparam(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate param attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateparam() = 0;

    /**
     * Gets or creates Mp7JrsNodePtr child elements of TemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType.
     * Currently just supports rudimentary XPath expressions as TemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType<br>
 * Located at: visual-2001.with.net.workaround.xsd, line 216<br>
 * Classified: Class<br>
 * Derived from: float (Value)<br>
 * Defined in visual-2001.with.net.workaround.xsd, line 216.<br>
 */
class MP7JRS_EXPORT Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType :
        public IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType
{
    friend class Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalTypeFactory; // constructs objects

public:
    /*
     * Sets the content of Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType     * @param item float
     */
    virtual void SetContent(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Retrieves the content of Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType 
     * @return float
     */
    virtual float GetContent() const;

    /*
     * Get type attribute.
     * @return Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::Enumeration
     */
    virtual Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::Enumeration Gettype() const;

    /*
     * Get type attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existtype() const;

    /*
     * Set type attribute.
     * @param item Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::Enumeration
     */
    virtual void Settype(Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate type attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatetype();

    /*
     * Get param attribute.
     * @return float
     */
    virtual float Getparam() const;

    /*
     * Get param attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existparam() const;

    /*
     * Set param attribute.
     * @param item float
     */
    virtual void Setparam(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate param attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateparam();

    /*
     * Gets or creates Mp7JrsNodePtr child elements of TemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType.
     * Currently just supports rudimentary XPath expressions as TemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType();

protected:
    Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::Enumeration m_type;
    bool m_type_Exist;
    Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::Enumeration m_type_Default;
    float m_param;
    bool m_param_Exist;
    float m_param_Default;

    // Base Value
    float m_Base;


// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2235MP7JRSTEMPORALINTERPOLATIONTYPE_INTERPOLATIONFUNCTIONS_KEYVALUE_LOCALTYPE_H

