/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2489MP7JRSVIDEOSEGMENTSPATIALDECOMPOSITIONTYPE_LOCALTYPE_H
#define _2489MP7JRSVIDEOSEGMENTSPATIALDECOMPOSITIONTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsVideoSegmentSpatialDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsVideoSegmentSpatialDecompositionType_LocalType_ExtInclude.h


class IMp7JrsMovingRegionType;
class IMp7JrsReferenceType;
class IMp7JrsVideoSegmentSpatialDecompositionType_LocalType;
typedef Mp7JrsPtr< IMp7JrsMovingRegionType > Mp7JrsMovingRegionPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsVideoSegmentSpatialDecompositionType_LocalType> Mp7JrsVideoSegmentSpatialDecompositionType_LocalPtr;

/** 
 * Generated interface IMp7JrsVideoSegmentSpatialDecompositionType_LocalType for class Mp7JrsVideoSegmentSpatialDecompositionType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsVideoSegmentSpatialDecompositionType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsVideoSegmentSpatialDecompositionType_LocalType();
    virtual ~IMp7JrsVideoSegmentSpatialDecompositionType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get MovingRegion element.
     * @return Mp7JrsMovingRegionPtr
     */
    virtual Mp7JrsMovingRegionPtr GetMovingRegion() const = 0;

    /**
     * Set MovingRegion element.
     * @param item const Mp7JrsMovingRegionPtr &
     */
    // Mandatory			
    virtual void SetMovingRegion(const Mp7JrsMovingRegionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get MovingRegionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetMovingRegionRef() const = 0;

    /**
     * Set MovingRegionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetMovingRegionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsVideoSegmentSpatialDecompositionType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsVideoSegmentSpatialDecompositionType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsVideoSegmentSpatialDecompositionType_LocalType<br>
 * Defined in mds-2001.xsd, line 3313.<br>
 */
class MP7JRS_EXPORT Mp7JrsVideoSegmentSpatialDecompositionType_LocalType :
        public IMp7JrsVideoSegmentSpatialDecompositionType_LocalType
{
    friend class Mp7JrsVideoSegmentSpatialDecompositionType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get MovingRegion element.
     * @return Mp7JrsMovingRegionPtr
     */
    virtual Mp7JrsMovingRegionPtr GetMovingRegion() const;

    /*
     * Set MovingRegion element.
     * @param item const Mp7JrsMovingRegionPtr &
     */
    // Mandatory			
    virtual void SetMovingRegion(const Mp7JrsMovingRegionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get MovingRegionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetMovingRegionRef() const;

    /*
     * Set MovingRegionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetMovingRegionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsVideoSegmentSpatialDecompositionType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsVideoSegmentSpatialDecompositionType_LocalType();

protected:
    Mp7JrsVideoSegmentSpatialDecompositionType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsMovingRegionPtr m_MovingRegion;
    Mp7JrsReferencePtr m_MovingRegionRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsVideoSegmentSpatialDecompositionType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2489MP7JRSVIDEOSEGMENTSPATIALDECOMPOSITIONTYPE_LOCALTYPE_H

