/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1291MP7JRSMINUSONETOONEVECTOR_LOCALTYPE_H
#define _1291MP7JRSMINUSONETOONEVECTOR_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsminusOneToOneVector_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsminusOneToOneVector_LocalType_ExtInclude.h


class IMp7JrsminusOneToOneVector_LocalType;
typedef Mp7JrsPtr< IMp7JrsminusOneToOneVector_LocalType> Mp7JrsminusOneToOneVector_LocalPtr;

/** 
 * Generated interface IMp7JrsminusOneToOneVector_LocalType for class Mp7JrsminusOneToOneVector_LocalType<br>
 * Located at: mds-2001.xsd, line 712<br>
 * Derived from: float (Value)<br>
 */
class MP7JRS_EXPORT IMp7JrsminusOneToOneVector_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsminusOneToOneVector_LocalType();
    virtual ~IMp7JrsminusOneToOneVector_LocalType();
    /**
     * Sets the content of Mp7JrsminusOneToOneVector_LocalType     * @param item float
     */
    virtual void SetContent(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Retrieves the content of Mp7JrsminusOneToOneVector_LocalType 
     * @return float
     */
    virtual float GetContent() const = 0;

// no includefile for extension defined 
// file Mp7JrsminusOneToOneVector_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsminusOneToOneVector_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsminusOneToOneVector_LocalType<br>
 * Located at: mds-2001.xsd, line 712<br>
 * Derived from: float (Value)<br>
 * Defined in mds-2001.xsd, line 712.<br>
 */
class MP7JRS_EXPORT Mp7JrsminusOneToOneVector_LocalType :
        public IMp7JrsminusOneToOneVector_LocalType
{
    friend class Mp7JrsminusOneToOneVector_LocalTypeFactory; // constructs objects

public:
    /*
     * Sets the content of Mp7JrsminusOneToOneVector_LocalType     * @param item float
     */
    virtual void SetContent(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Retrieves the content of Mp7JrsminusOneToOneVector_LocalType 
     * @return float
     */
    virtual float GetContent() const;


    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsminusOneToOneVector_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsminusOneToOneVector_LocalType();

protected:
    Mp7JrsminusOneToOneVector_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Value
    float m_Base;


// no includefile for extension defined 
// file Mp7JrsminusOneToOneVector_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1291MP7JRSMINUSONETOONEVECTOR_LOCALTYPE_H

