/*****************************************************************************/
/* Copyright (C) 2003-2006, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// PatternType_H

#ifndef _2597MP7JRSXPATHREFTYPE_H
#define _2597MP7JRSXPATHREFTYPE_H


#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsxPathRefTypeFactory.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>
#include "Mp7JrsConvert.h"

// no includefile for extension defined 
// file Mp7JrsxPathRefType_ExtInclude.h



/**
 * Generated interface IMp7JrsxPathRefType for Pattern Mp7JrsxPathRefType
 */
class MP7JRS_EXPORT IMp7JrsxPathRefType :
	public Mp7JrsNode
{
public:
	virtual XMLCh * GetContent() const = 0;

	virtual void SetContent(XMLCh * val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


// no includefile for extension defined 
// file Mp7JrsxPathRefType_ExtMethodDef.h


};

/*
 * Generated pattern Mp7JrsxPathRefType<br>
 * Located at: mds-2001.xsd, line 878<br>
 * Regular expression: <br>
 * /?((((child::)?((\i\c*:)?(\i\c*)(\[\d+\])?))|\.|(\.\.))/)*((((child::)?((\i\c*:)?(\i\c*)(\[\d+\])?))|\.)|((attribute::|@)((\i\c*:)?(\i\c*|\*))))<br>
 * Mapped to string<br>
 */
class MP7JRS_EXPORT Mp7JrsxPathRefType :
	public IMp7JrsxPathRefType
{
	friend class Mp7JrsxPathRefTypeFactory;
	
public: 
	virtual XMLCh * GetContent() const;

	virtual void SetContent(XMLCh * val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	virtual XMLCh * ToText() const;
	virtual bool Parse(const XMLCh * const txt);

	virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);
	virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent,  XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

// no includefile for extension defined 
// file Mp7JrsxPathRefType_ExtMyMethodDef.h


	virtual ~Mp7JrsxPathRefType();

protected:
	Mp7JrsxPathRefType();
	virtual void DeepCopy(const Mp7JrsNodePtr &original);
	virtual Mp7JrsNodeEnum GetAllChildElements() const { return Mp7JrsNodeEnum(); }

	virtual Mp7JrsNodePtr GetBaseRoot();
	virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
	XMLCh * m_Content;

// no includefile for extension defined 
// file Mp7JrsxPathRefType_ExtPropDef.h


protected:
	void Init();
	void Cleanup();
};

#endif // _2597MP7JRSXPATHREFTYPE_H

